unit sGraphUtils;       
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.3, 10-03-2002
*************************************************************************)

interface

{$I Rx.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, sConst, ExtCtrls, Jpeg, sUtils;

type
  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;

procedure PaintCheck(Canvas: TCanvas; r: TRect; Enabled: boolean; Color: TColor);
procedure WriteText(Canvas: TCanvas; Text: PChar; Enabled: boolean; var aRect : TsRect; Flags: Longint);
function TextRect(DC: HDC; Font: TFont; Text: string; var aRect: TRect; Flags: longint): TRect;
procedure FadeByMask(FadedBmp : TBitmap; Mask : TGraphic; aRect: TRect; Transparency: integer; Color: TColor);
procedure FadeBmp(FadedBmp: TBitMap; aRect: TRect;Transparency: integer; Color: TColor; Blur, Radius : integer);
procedure FadeRect(CanvasSrc: TCanvas; RSrc: TRect; CanvasDst: TCanvas; PDst: TPoint; Transparency: integer; Color: TColor; Blur : integer; Shape: TsShadowingShape);
procedure SumBitmaps(SrcBmp, MskBmp: Graphics.TBitMap; t, Blur : real; Color : TColor);
procedure GradientBmp(Bmp: Graphics.TBitMap; aRect : TRect; Color1, Color2 : TColor; Layout : TGradientTypes);
procedure ScaleBmp(Src, Dst: TBitmap; k : integer);

function LightingColor(Color : TColor; Limit: integer; i : real) : TColor;
function DarkingColor(Color : TColor; Limit: integer; i : real) : TColor;
{  }
procedure DrawRectangleOnDC(DC: HDC; var R: TRect; ColorTop, ColorBottom: TColor; var Width: integer);
procedure TileBitmap(Canvas: TCanvas; Rect: TRect; Graphic: TGraphic);
{     }
function GetFontHeight(hFont : HWnd): integer;
{   BMP  jpg  bmp }
function LoadJpegOrBmp(Bmp: TBitmap; FileName: string; Monochrome:boolean):boolean;
{   -   ...}
procedure ShowOnlyControls(Form:TForm; ShowCaption,Value:boolean);
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

implementation

//uses sPanel;

procedure PaintCheck(Canvas: TCanvas; r: TRect; Enabled: boolean; Color: TColor);
var
  h, w: integer;
  aRect: TRect;
  procedure Paint(r: TRect); begin
    aRect := r;
    InflateRect(aRect, - WidthOf(r) div 8, - WidthOf(r) div 8);
    inc(aRect.Left, 1);
    inc(aRect.Top, 1);
    h := HeightOf(aRect);
    w := h div 4;
    Canvas.Polygon([
                    Point(aRect.Left,            aRect.Bottom - h div 3 - 2),
                    Point(aRect.Left + h div 3,  aRect.Bottom - 2),
                    Point(aRect.Right - 2,       aRect.Top + h div 3),
                    Point(aRect.Right - 2,       aRect.Top + h div 3 - w),
                    Point(aRect.Left + h div 3,  aRect.Bottom - 2 - w),
                    Point(aRect.Left + w,        aRect.Bottom - h div 3 - 2)
                                    ])
  end;
begin
  Canvas.Brush.Style := bsSolid;
  Canvas.Pen.Style := psSolid;
  if Enabled then begin
    Canvas.pen.color := Color;
    Canvas.brush.color := Color;
  end
  else begin
    Canvas.brush.color := cl3DLight;
    Canvas.pen.color := cl3DLight;

    OffsetRect(r, 1, 1);
    Paint(r);
    OffsetRect(r, -1, -1);

    Canvas.brush.color := clBtnShadow;
    Canvas.pen.color := clBtnShadow;
  end;
  Paint(r);
end;

procedure WriteText(Canvas: TCanvas; Text: PChar; Enabled: boolean; var aRect : TsRect; Flags: Longint);
var
  R, Rd: TRect;
  x, y : integer;
  ts: TSize;
begin
  R := aRect;

  if Flags or DT_WORDBREAK <> Flags then begin // If no multiline
  
    GetTextExtentPoint32(Canvas.Handle, Text, Length(Text), ts);
    R.Right := R.Left + ts.cx;
    R.Bottom := R.Top + ts.cy;

    if Flags or DT_CENTER = Flags then begin
      y := (HeightOf(R) - HeightOf(aRect)) div 2;
      x := (WidthOf(R) - WidthOf(aRect)) div 2;
      InflateRect(aRect, x, y);
    end
    else if Flags or DT_RIGHT = Flags then begin
      y := (HeightOf(R) - HeightOf(aRect)) div 2;
      dec(aRect.Top, y);
      inc(aRect.Bottom, y);
      inc(aRect.Left, WidthOf(aRect) - WidthOf(R));
    end
    else if Flags or DT_LEFT = Flags then begin
      y := (HeightOf(R) - HeightOf(aRect)) div 2;
      dec(aRect.Top, y);
      inc(aRect.Bottom, y);
      inc(aRect.Right, WidthOf(R) - WidthOf(aRect));
    end;


    R := aRect;// := R;
    InflateRect(aRect, 1, 1);
  end;
  
  Canvas.Brush.Style := bsClear;
  if Enabled then begin
    DrawText(Canvas.Handle, Text, Length(Text), R, Flags);
  end
  else begin
    Rd := Rect(R.Left + 1, R.Top + 1, R.Right + 1, R.Bottom + 1);
    Canvas.Font.Color := ColorToRGB(clBtnHighlight);
    DrawText(Canvas.Handle, Text, Length(Text), Rd, Flags);

    Canvas.Font.Color := ColorToRGB(clBtnShadow);
    DrawText(Canvas.Handle, Text, Length(Text), R, Flags);
  end;
end;

function TextRect(DC: HDC; Font: TFont; Text: string; var aRect: TRect; Flags: longint): TRect;
var
  OldFont: HFont;
begin
  if Font.Handle <> 0 then begin
    OldFont := SelectObject(DC, Font.Handle)
  end
  else begin
    OldFont := 0;
  end;
  try
    DrawText(DC, PChar(Text), -1, aRect, DT_NOPREFIX or Flags or DT_CALCRECT);
    Result := aRect;
  finally
    if OldFont <> 0 then SelectObject(DC, OldFont);
  end;
end;

procedure FadeRect(CanvasSrc: TCanvas; RSrc: TRect; CanvasDst: TCanvas; PDst: TPoint; Transparency: integer; Color: TColor; Blur : integer; Shape: TsShadowingShape);
var
  Bmp, TempBmp : Graphics.TBitmap;
  c: TColor;
//  r: TRect;
  delta: real;
  RValue, GValue, BValue,
  i, j : integer;
  MskColor : TColor;

begin
  if Assigned(CanvasDst) then begin
    case Transparency of
      100: begin
//        BitBlt(CanvasDst.Handle,
//               PDst.x, PDst.y, WidthOf(RSrc), HeightOf(RSrc), CanvasSrc.Handle,
//               RSrc.Left, RSrc.Top, SRCCOPY);
//        BitBlt(CanvasDst.Handle, PDst.x, PDst.y, Bmp.Width, Bmp.Height, Bmp.Canvas.Handle, 0, 0, SRCCOPY);
        CanvasDst.CopyRect(Rect(PDst.x, PDst.y, PDst.x + WidthOf(RSrc), PDst.y + HeightOf(RSrc)),
                           CanvasSrc,
                           RSrc);
      end;
      0: begin
        CanvasDst.Pen.Style := psClear;
        CanvasDst.Brush.Style := bsSolid;
        CanvasDst.Brush.Color := Color;
        CanvasDst.Rectangle(Rect(PDst.x, PDst.y, PDst.x + RSrc.Right - RSrc.Left, PDst.y + RSrc.Bottom - RSrc.Top));
      end
      else begin
        Bmp := Graphics.TBitmap.Create; Bmp.PixelFormat := pf24bit; Bmp.Width := WidthOf(rSrc); Bmp.Height := HeightOf(rSrc);
        TempBmp := Graphics.TBitmap.Create; TempBmp.PixelFormat := pf24bit; TempBmp.Width := Bmp.Width; TempBmp.Height := Bmp.Height;
        Blur := Mini(Mini(TempBmp.Width div 2, TempBmp.Height div 2), Blur);

        MskColor := RGB(255 * Transparency div 100, 255 * Transparency div 100, 255 * Transparency div 100);
        RValue := GetRValue(MskColor);
        GValue := RValue;
        BValue := RValue;

        bitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, CanvasSrc.Handle, RSrc.Left, RSrc.Top, SrcCopy);
//        Bmp.Canvas.CopyRect(Rect(0, 0, WidthOf(RSrc), HeightOf(RSrc)),
//                           CanvasSrc,
//                           RSrc);

        delta := (255 - RValue) / (Blur + 1);
        // Prepare mask
        c := clWhite;
        TempBmp.Canvas.Pen.Style := psClear;
        TempBmp.Canvas.Brush.Style := bsSolid;
        TempBmp.Canvas.Brush.Color := clWhite;
        case Shape of
          ssRectangle: begin
            for i := 0 to Blur do begin
              TempBmp.Canvas.Brush.Color := c;
              TempBmp.Canvas.RoundRect(i, i, TempBmp.Width - i + 1, TempBmp.Height - i + 1, Blur, Blur);
              j := GetRValue(MskColor) + Round(delta * (Blur - i)) mod 256;
              c := RGB(j, j, j);
            end;
            TempBmp.Canvas.Brush.Color := c;
            TempBmp.Canvas.RoundRect(i, i, TempBmp.Width - i + 1, TempBmp.Height - i + 1, Blur, Blur);
          end;
          ssEllipse: begin
            for i := 0 to Blur do begin
              TempBmp.Canvas.Brush.Color := c;
              TempBmp.Canvas.Ellipse(Rect(i, i, TempBmp.Width - i, TempBmp.Height - i));

              j := GetRValue(MskColor) + Round(delta * (Blur - i)) mod 256;
              c := RGB(j, j, j);
            end;
            TempBmp.Canvas.Brush.Color := c;
            TempBmp.Canvas.Ellipse(Rect(i, i, TempBmp.Width - i, TempBmp.Height - i));
          end;
        end;

        SumBitmaps(Bmp, TempBmp, Transparency / 100, Blur, Color);

        // Copy back
        // Comment for mask-image verify
  //      BitBlt(CanvasDst.Handle, PDst.x, PDst.y, Bmp.Width, Bmp.Height, TempBmp.Canvas.Handle, 0, 0, SRCCOPY);
{        CanvasDst.CopyRect(Rect(PDst.x, PDst.y, PDst.x + Bmp.Width, PDst.y + Bmp.Height),
                           Bmp.Canvas,
                           Rect(0, 0, Bmp.Width, Bmp.Height));
}
        BitBlt(CanvasDst.Handle, PDst.x, PDst.y, Bmp.Width + 1, Bmp.Height + 1, Bmp.Canvas.Handle, 0, 0, SRCCOPY);
        FreeAndNil(Bmp);
        FreeAndNil(TempBmp);
      end;
    end;
//    RestoreDC(CanvasDst.Handle, SavedDDC);
//    RestoreDC(CanvasSrc.Handle, SavedSDC);
  end;
end;

procedure FadeBmp(FadedBmp: TBitMap; aRect: TRect; Transparency: integer; Color: TColor; Blur, Radius : integer);
var
  Bmp, TempBmp : Graphics.TBitmap;
  c: TColor;
  r: TRect;
  delta: real;
  RValue, GValue, BValue,
  {kef, }i, j : integer;
  MskColor : TColor;
begin
  Bmp := Graphics.TBitmap.Create; Bmp.PixelFormat := pf24bit; Bmp.Width := aRect.Right - aRect.Left; Bmp.Height := aRect.Bottom - aRect.Top;
  TempBmp := Graphics.TBitmap.Create; TempBmp.PixelFormat := pf24bit; TempBmp.Width := Bmp.Width; TempBmp.Height := Bmp.Height;
  Blur := Mini(Mini(TempBmp.Width div 2, TempBmp.Height div 2), Blur);
  Radius := Mini(Mini(TempBmp.Width div 2, TempBmp.Height div 2), Radius);

  MskColor := RGB(255 * Transparency div 100, 255 * Transparency div 100, 255 * Transparency div 100);
//  MskColor := clGray; //clBlack;
  RValue := GetRValue(MskColor); GValue := RValue; BValue := RValue;

  // Copy faded area in Ftb
  bitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, FadedBmp.Canvas.Handle, aRect.Left, aRect.Top, SrcCopy);

  TempBmp.Canvas.Pen.Style := psClear;
  TempBmp.Canvas.Brush.Style := bsSolid;
  TempBmp.Canvas.Brush.Color := clWhite;

  delta := (255 - RValue) / (Blur + 1);
  // Prepare template
  c := clWhite;
  for i := 0 to Blur do begin

    r := Rect(i, i, TempBmp.Width - i, TempBmp.Height - i);
    TempBmp.Canvas.Brush.Color := c;
    TempBmp.Canvas.RoundRect(i, i, TempBmp.Width - i, TempBmp.Height - i, Radius, Radius);

    j := GetRValue(MskColor) + Round(delta * (Blur - i)) mod 256;
    c := RGB(j, j, j);
  end;
  r := Rect(i, i, TempBmp.Width - i, TempBmp.Height - i);


  TempBmp.Canvas.Pen.Style := psClear;
  TempBmp.Canvas.Brush.Style := bsSolid;

  TempBmp.Canvas.Brush.Color := c;
  TempBmp.Canvas.RoundRect(r.Left, R.Top, R.Right, R.Bottom, Blur, Blur);

  SumBitmaps(Bmp, TempBmp, Transparency/100, Blur, Color);

  // Copy back
  BitBlt(FadedBmp.Canvas.Handle, aRect.Left, aRect.Top, Bmp.Width, Bmp.Height, Bmp.Canvas.Handle, 0, 0, SRCCOPY);
//  BitBlt(FadedBmp.Canvas.Handle, aRect.Left, aRect.Top, Bmp.Width, Bmp.Height, TempBmp.Canvas.Handle, 0, 0, SRCCOPY);
  FreeAndNil(Bmp);
  FreeAndNil(TempBmp);
end;

procedure FadeByMask(FadedBmp: TBitMap; Mask: TGraphic; aRect: TRect; Transparency: integer; Color: TColor);
var
  Bmp : Graphics.TBitmap;
  r: TRect;
begin
  Bmp := Graphics.TBitmap.Create;


  Bmp.PixelFormat := pf24bit;

  Bmp.Width := aRect.Right - aRect.Left;
  Bmp.Height := aRect.Bottom - aRect.Top;

  r := Bounds(0, 0, Bmp.Width, Bmp.Height);

  if Assigned(Mask) then begin
    TileBitmap(Bmp.Canvas, R, Mask);
  end;

  FadedBmp.Assign(Bmp);

//  SumBitmaps(FadedBmp, Bmp, Transparency/100, 0, Color);

  FreeAndNil(Bmp);
end;

procedure SumBitmaps(SrcBmp, MskBmp: Graphics.TBitMap; t, Blur : real; Color : TColor);
type
  TsRGB = packed record
    B: Byte;
    G: Byte;
    R: Byte;
  end;
  PRGBArray = ^TRGBArray;
  TRGBArray = array[0..1000000] of TsRGB;
var
  SSrc, SDst : PRGBArray;
  X, Y{, i}: Integer;
  R, G, B : real;

begin
  R := GetRValue(Color) / 255;
  G := GetGValue(Color) / 255;
  B := GetBValue(Color) / 255;
{
  if R < 0.01 then R := 0;
  if G < 0.01 then G := 0;
  if B < 0.01 then B := 0;
}
//  KEF := t * 255;
  for Y := 0 to SrcBmp.Height - 1 do begin
    SSrc := SrcBmp.ScanLine[Y];
    SDst := MskBmp.ScanLine[Y];
    for X := 0 to SrcBmp.Width - 1 do begin
      SSrc[X].R :=Round(
           (SSrc[X].R * SDst[X].R +
           (SDst[X].R + 100) * (255 - SDst[X].R) * R) / 255     // 100 ??? -
                   ) mod 256;                                   //  ..
      SSrc[X].G := Round(                                       //   
           (SSrc[X].G * SDst[X].G +
           (SDst[X].G + 100) * (255 - SDst[X].G) * G) / 255
                   ) mod 256;
      SSrc[X].B := Round(
           (SSrc[X].B * SDst[X].B +
           (SDst[X].B + 100) * (255 - SDst[X].B) * B) / 255
                   ) mod 256;
    end
  end;
end;

procedure GradientBmp(Bmp: Graphics.TBitMap; aRect : TRect; Color1, Color2 : TColor; Layout : TGradientTypes);
var
  SSrc : PRGBArray;
  X, Y{, i}: Integer;
  R, G, B : real;
  RStep, GStep, BStep : real;
  SavedDC : longint;
begin
  SavedDC := SaveDC(Bmp.Canvas.Handle);
  try
    R := GetRValue(Color1);
    G := GetGValue(Color1);
    B := GetBValue(Color1);
    Bmp.PixelFormat := pf24bit;
    case Layout of
      gtLeftRight : begin
        RStep := (GetRValue(Color2) - GetRValue(Color1)) / Bmp.Width;
        GStep := (GetGValue(Color2) - GetGValue(Color1)) / Bmp.Width;
        BStep := (GetBValue(Color2) - GetBValue(Color1)) / Bmp.Width;
        for Y := 0 to Bmp.Height - 1 do begin
          SSrc := Bmp.ScanLine[Y];
          R := GetRValue(Color1);
          G := GetGValue(Color1);
          B := GetBValue(Color1);
          for X := 0 to Bmp.Width - 1 do begin
            SSrc[X].R := Round(R);
            SSrc[X].G := Round(G);
            SSrc[X].B := Round(B);
            R := R + RStep;
            G := G + GStep;
            B := B + BStep;
          end;
        end;
      end;
      gtTopBottom : begin
        RStep := (GetRValue(Color2) - R) / Bmp.Height;
        GStep := (GetGValue(Color2) - G) / Bmp.Height;
        BStep := (GetBValue(Color2) - B) / Bmp.Height;
        for Y := 0 to Bmp.Height - 1 do begin
          SSrc := Bmp.ScanLine[Y];
          for X := 0 to Bmp.Width - 1 do begin
            SSrc[X].R := Round(R);
            SSrc[X].G := Round(G);
            SSrc[X].B := Round(B);
          end;
          R := R + RStep;
          G := G + GStep;
          B := B + BStep;
        end;
      end;
    end;
  except
    RestoreDC(Bmp.Canvas.Handle, SavedDC);
  end;
end;

procedure ScaleBmp(Src, Dst: TBitmap; k : integer);
var
  SSrc, SDst : PRGBArray;
  X, Y, i, j: Integer;
begin
  Src.PixelFormat := pf24bit;
  Dst.PixelFormat := pf24bit;
  Dst.Width := Src.Width * k;
  Dst.Height := Src.Height * k;
  for Y := 0 to Src.Height - 1 do begin

    SSrc := Src.ScanLine[Y];
    for i := 0 to k - 1 do begin

      SDst := Dst.ScanLine[Y * k + i];
      for X := 0 to Src.Width - 1 do begin
        for j := 0 to k - 1  do begin
          SDst[x * k + j] := SSrc[x];
        end;
      end;
    end;

  end;
end;

function LightingColor(Color : TColor; Limit: integer; i : real) : TColor;
var
  r, g, b : integer;
begin
  r := Round(GetRValue(Color) + (Limit - GetRValue(Color)) * i);
  g := Round(GetGValue(Color) + (Limit - GetGValue(Color)) * i);
  b := Round(GetBValue(Color) + (Limit - GetBValue(Color)) * i);
  Result := RGB(iffi(r > 255, 255, r), iffi(g > 255, 255, g), iffi(b > 255, 255, b));
end;

function DarkingColor(Color : TColor; Limit: integer; i : real) : TColor;
var
  r, g, b : integer;
begin
  r := Round(Limit * (1 - i) + GetRValue(Color) * i);
  g := Round(Limit * (1 - i) + GetGValue(Color) * i);
  b := Round(Limit * (1 - i) + GetBValue(Color) * i);
  Result := RGB(iffi(r > 255, 255, r), iffi(g > 255, 255, g), iffi(b > 255, 255, b));
end;
{
function DarkingColor(Color : TColor; i : integer) : TColor;
begin
  Result := RGB(GetRValue(Color) div i, GetGValue(Color) div i, GetBValue(Color) div i);
end;
}
procedure DrawRectangleOnDC(DC: HDC; var R: TRect; ColorTop, ColorBottom: TColor; var Width: integer);
var
  PenTop, PenBottom, OldPen : hPen;
  OldBrush : hBrush;
  Points : Array [0..2] of TPoint;
  procedure DoRect;
  var
    TopRight, BottomLeft: TPoint;
  begin
    with R do begin
      TopRight.X := Right;
      TopRight.Y := Top;
      BottomLeft.X := Left;
      BottomLeft.Y := Bottom;

      Points[0] := BottomLeft;
      Points[1] := TopLeft;
      Points[2] := TopRight;
      SelectObject(dc, PenTop);
      PolyLine(DC, PPoints(@Points)^, 3);

      Dec(BottomLeft.X);

      Points[0] := TopRight;
      Points[1] := BottomRight;
      Points[2] := BottomLeft;
      SelectObject(dc, PenBottom);
      PolyLine(DC, PPoints(@Points)^, 3);
    end;
  end;
begin
  PenTop := CreatePen(PS_SOLID, 1, ColorToRGB(ColorTop));
  PenBottom := CreatePen(PS_SOLID, 1, ColorBottom);
  OldPen := SelectObject(dc, PenTop);
  OldBrush := SelectObject(dc, GetStockObject(NULL_BRUSH));

  Dec(R.Bottom);
  Dec(R.Right);

  while Width > 0 do begin
    Dec(Width);
    DoRect;
    InflateRect(R, -1, -1);
  end;
  Inc(R.Bottom); Inc(R.Right);

  SelectObject(dc, OldPen);
  SelectObject(dc, OldBrush);
  DeleteObject(PenTop);
  DeleteObject(PenBottom);
end;
{
procedure Line3D(Canvas : TCanvas; P1, P2: TPoint; ColorTop, ColorBottom : TColor; Width : integer);
begin
  Canvas.Pen.Style := psSolid;
  Canvas.Brush.Style := bsClear;
  Canvas.Pen.Color := ColorTop;
  Canvas.MoveTo(P1.x, P1.y);
  Canvas.LineTo(P2.x, P2.y);
  Canvas.Pen.Color := ColorBottom;
  Canvas.MoveTo(P1.x + 1, P1.y);
  Canvas.LineTo(P2.x + 1, P2.y);
end;
}
procedure TileBitmap(Canvas: TCanvas; Rect: TRect; Graphic: TGraphic);
var
  X, Y, cx, cy: Integer;
  SaveIndex: Integer;
begin
  if (Graphic.Width = 0) or (Graphic.Height = 0) then Exit;
  SaveIndex := SaveDC(Canvas.Handle);
  try
//    IntersectClipRect(Canvas.Handle, Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
    cx := WidthOf(Rect) div Graphic.Width;
    cy := HeightOf(Rect) div Graphic.Height;

    for X := 0 to cx do
      for Y := 0 to cy do
        Canvas.Draw(Rect.Left + X * Graphic.Width,
                    Rect.Top + Y * Graphic.Height,
                    Graphic);
  finally
    RestoreDC(Canvas.Handle, SaveIndex);
  end;
end;

function GetFontHeight(hFont : HWnd): integer;
var
  DC: HDC;
  SaveFont: LongInt;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, hFont);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  Result := Metrics.tmHeight + 6;
end;

{
function GetTextWidth(hFont : HWnd; Text: string): integer;
var
  DC: HDC;
  SaveFont: LongInt;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, hFont);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  Result := Metrics.tmHeight + 6;
end;
}
function LoadJpegOrBmp(Bmp: TBitmap; FileName: string; Monochrome:boolean):boolean;
var
  s:string;
  j:TJpegImage;
begin
  Result:=False;
  try
    if FileExists(FileName) then begin
      s:=ExtractFileExt(FileName);
      if (UpperCase(s)='.JPG') or (UpperCase(s)='.JPEG') then begin
        j:=TJPEGImage.Create;
        j.LoadFromFile(FileName);
        j.Grayscale:=Monochrome;
        Bmp.Assign(TGraphic(j));
        FreeAndNil(j);
      end
      else begin
        Bmp.LoadFromFile(FileName);
        if Monochrome then begin
          Bmp.PixelFormat:=pf24bit;
          Bmp.Monochrome:=True;
        end;
      end;
      Result:=True;
    end
    else begin
      Bmp.Assign(nil);
    end;
  except
  end;
end;

procedure ShowOnlyControls(Form:TForm; ShowCaption, Value:boolean);
var
  i,x,y:integer;
  FRegion,h1:HRGN;
begin
{$IFDEF RX_D5}
  GetWindowRgn(Form.Handle,FRegion);
  DeleteObject(FRegion);
{$ELSE}
  if GetWindowRgn(Form.Handle,FRegion) then DeleteObject(FRegion);
{$ENDIF}
  if Value then begin
    x:=GetSystemMetrics(SM_CXDLGFRAME);
    y:=GetSystemMetrics(SM_CYDLGFRAME)+GetSystemMetrics(SM_CYCAPTION);

    FRegion:=CreateRectRgnIndirect(Bounds(0,0,0,0));

    if ShowCaption then begin
      h1:=CreateRectRgnIndirect(Bounds(0,0,Form.width,y+1));
      CombineRgn(FRegion,FRegion,h1,RGN_OR);
      DeleteObject(h1);
    end;

    for i:=0 to Form.ComponentCount-1 do begin
      if Form.Components[i] is TControl then begin
        h1:=CreateRectRgnIndirect(TControl(Form.Components[i]).BoundsRect);//(Panel1.Left+1,22+Panel1.Top+1,Panel1.Width,Panel1.Height)
        OffsetRgn(h1, x+1, y+1);
        CombineRgn(FRegion,FRegion,h1,RGN_OR);
        DeleteObject(h1);
      end;
    end;
  end
  else begin
    FRegion:=CreateRectRgnIndirect(Bounds(0,0,Form.Width,Form.Height));
  end;
  SetWindowRgn(Form.Handle,FRegion,true);
end;

end.
